/**
 * $Id: common.h 12 2006-05-01 23:59:34Z alexeen $
 */
#ifndef __COMMON_H__
#define __COMMON_H__

/** Version information. **/
#define VERSION "0.3"

/** Define this to remove debug statements and assertions. **/
#define NDEBUG

/** Maximum buffer length. **/
#define BUFLEN 1024

/** Maximum number of workers in thread pool. **/
#define MAXWORKERS 100

/**
 * Define this to not compile with IDENT support.
 * "libident" is required.
 **/
#undef NIDENT

/** Ident query timeout value in seconds. **/
#define IDENT_TIMEOUT 5

/** Define to hide the process real title. **/
#define HIDE_PROC_TITLE

/** Process name to set to if chosen to hide the real process name. **/
#define FAKE_PROC_NAME "[kthreadmon]"

/** Process title to set to if chosen to hide the real process title. **/
#define FAKE_PROC_TITLE ""

/** Define if you have vnsprintf on your system. **/
#define HAVE_VSNPRINTF

/** Define if you wish to use vnsprintf for setting process title. **/
#define USE_VSNPRINTF

/** Select timeout values (struct timeval). **/
#define SEL_TO_S 5
#define SEL_TO_US 0

#endif /** __COMMON_H__ **/
