/**
 * $Id: droproot.c 1 2006-04-29 18:51:20Z alexeen $
 */
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <pwd.h>

#include "droproot.h"
#include "common.h"

/**
 * drop_root: Drops all root privileges if running as root.
 * @return Returns 0 for success, -1 otherwise.
 */
int drop_root()
{
	/** Store user info from passwd DB. **/
	struct passwd *p = NULL;

	switch(getuid())
	{
		case 0: /** Running as privileged user. **/
			p = getpwnam("nobody"); /** Change to nobody. **/
			if (!p)
			{
#ifndef NDEBUG
perror("Unable to find UID for `nobody'");
#endif
				return -1;
			}

			if (setuid(p->pw_uid))
			{
#ifndef NDEBUG
perror("Unable to change to UID for `nobody'");
#endif
				return -1;
			}
			break;
	}

	return 0;
}
