/**
 * $Id: sighandler.c 10 2006-05-01 03:55:01Z alexeen $
 */
#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include <assert.h>

#include "sighandler.h"
#include "common.h"

/** Keeps track if program is still listening for connections. **/
extern char listening;

/**
 * setup_sighandlers: Setup signal handlers.
 */
void setup_sighandlers()
{
	if (SIG_IGN == signal(SIGINT, termination_handler))
	{
		/** If previously set to ignored, we'll keep ignoring it. **/
		signal(SIGINT, SIG_IGN);
	}

	if (SIG_IGN == signal(SIGHUP, termination_handler))
	{
		/** If previously set to ignored, we'll keep ignoring it. **/
		signal(SIGINT, SIG_IGN);
	}

	if (SIG_IGN == signal(SIGTERM, termination_handler))
	{
		/** If previously set to ignored, we'll keep ignoring it. **/
		signal(SIGINT, SIG_IGN);
	}
}

/**
 * termination_handler: Gracefully exists the program.
 * @param signum - The signal number being handled.
 */
void termination_handler(int signum)
{
	assert(001 == (001 & listening));

	listening = 000; /** Gracefully exists. **/
}
